/* =========================================================================
	This library is part of IshiSoft base class.
	------------------------------------------------------------------------
	author: Yuichiro Ishitani
			http://www001.upp.so-net.ne.jp/ishi/index.html
  ========================================================================== */
#if !defined(AFX_MXRECORD_H__308B1C91_8C07_403C_8A89_BE9F01DFB5AE__INCLUDED_)
#define AFX_MXRECORD_H__308B1C91_8C07_403C_8A89_BE9F01DFB5AE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#define MXRECORD_SUCCESS				(1)
#define MXRECORD_ERR_NOMEMORY			(-1)
#define MXRECORD_ERR_BADDNSHOSTNAME		(-2)
#define MXRECORD_ERR_DNSSERVERERROR		(-3)
#define MXRECORD_ERR_CONNECTFAILED		(-4)
#define MXRECORD_ERR_SOCKETERROR		(-5)
#define MXRECORD_ERR_DNSTIMEOUT			(-6)
#define MXRECORD_ERR_DNSBADREPLY		(-7)



#define MXR_MAX_MX_RECORDS				32		// This class lib. contain max 32 MX records.

/* RFC 1035 -------------------------------------------------------------------
3.2.2. TYPE values
 TYPE fields are used in resource records.  Note that these types are a subset
 of QTYPEs.

3.2.3. QTYPE values
 QTYPE fields appear in the question part of a query.
 QTYPES are a superset of TYPEs, hence all TYPEs are valid QTYPEs.
 In addition, the following QTYPEs are defined:
-----------------------------------------------------------------------------*/
#define DNS_TYPE_A		1			// a host address
#define DNS_TYPE_NS		2			// an authoritative name server
#define DNS_TYPE_MD		3			// a mail destination (Obsolete - use MX)
#define DNS_TYPE_MF		4			// a mail forwarder (Obsolete - use MX)
#define DNS_TYPE_CNAME	5			// the canonical name for an alias
#define DNS_TYPE_SOA	6			// marks the start of a zone of authority
#define DNS_TYPE_MB		7			// a mailbox domain name (EXPERIMENTAL)
#define DNS_TYPE_MG		8			// a mail group member (EXPERIMENTAL)
#define DNS_TYPE_MR		9			// a mail rename domain name (EXPERIMENTAL)
#define DNS_TYPE_NULL	10			// a null RR (EXPERIMENTAL)
#define DNS_TYPE_WKS	11			// a well known service description
#define DNS_TYPE_PTR	12			// a domain name pointer
#define DNS_TYPE_HINFO	13			// host information
#define DNS_TYPE_MINFO	14			// mailbox or mail list information
#define DNS_TYPE_MX		15			// mail exchange
#define DNS_TYPE_TXT	16			// text strings
#define DNS_TYPE_AXFR	252			// A request for a transfer of an entire zone
#define DNS_TYPE_MAILB	253			// A request for mailbox-related records (MB, MG or MR)
#define DNS_TYPE_MAILA	254			// A request for mail agent RRs (Obsolete - see MX)
#define DNS_TYPE_ALL	255			// A request for all records

/* RFC 1035 -------------------------------------------------------------------
3.2.4. CLASS values
 CLASS fields appear in resource records.
 The following CLASS mnemonics and values are defined:
-----------------------------------------------------------------------------*/
#define DNS_CLASS_IN	1			// the Internet
#define DNS_CLASS_CS	2			// the CSNET class (Obsolete)
#define DNS_CLASS_CH	3			// the CHAOS class
#define DNS_CLASS_HS	4			// Hesiod [Dyer 87]

typedef unsigned short DNS_TYPE;
typedef unsigned short DNS_QTYPE;
typedef unsigned short DNS_QCLASS;


typedef struct _MX
{
	unsigned short usPreference;
	char* pszDName;
} MX;

class MXRecord  
{
public:
	int InitDll(int nInit);
	MXRecord();
	virtual ~MXRecord();

	MX m_MX[MXR_MAX_MX_RECORDS+1];	// max 32 records. 33 is terminater. 

	int QueryDNS( const char* pszDNS, const char* pszQuestion, unsigned int dwTimeOut );
	const char* GetFirstMXRecord();
	const char* GetNetxtMXRecord( const char* );
};

#endif // !defined(AFX_MXRECORD_H__308B1C91_8C07_403C_8A89_BE9F01DFB5AE__INCLUDED_)
