/* =========================================================================
	This library is part of IshiSoft application.
	------------------------------------------------------------------------
	author: Yuichiro Ishitani
			http://www001.upp.so-net.ne.jp/ishi/index.html
  ========================================================================== */
#include "stdafx.h"
#include "MyConf.h"
#include "staticvariable.h"

MyConf::MyConf()
{
	/* common directory */
	Set(CONFIG_HOMEDIR,					"\\ismtp\\local\\");
	Set(CONFIG_TMPDIR,					"\\ismtp\\tmp\\");
	Set(CONFIG_QUEUEDIR,				"\\ismtp\\queue\\");
	Set(CONFIG_POPAUTHDIR,				"\\ismtp\\popauth\\");

	/* daemon schedule */
	Set(CONFIG_CLEANUPTIMER,			"1800" );
	Set(CONFIG_SENDMAILROUNDTIMER,		"1200" );
	Set(CONFIG_QUEUELIFETIME,			"172800" );
	
	/* pop before smtp */
	Set(CONFIG_POPBEFORESMTP,			"On" );
	Set(CONFIG_POPAUTHTIMEOUT,			"1800");

	/* DNS server */
//	Set(CONFIG_1ST_DNSSERVER,			"127.0.0.1");
//	Set(CONFIG_2ND_DNSSERVER,			"127.0.0.1");
	Set(CONFIG_DNSQUERYTIMEOUT,			"30");

	/* smtp server */
	Set(CONFIG_SMTPSERVERS,				"4");
	Set(CONFIG_SMTPPORT,				"25");
	Set(CONFIG_ME,						"localhost");
	Set(CONFIG_RCPTHOSTS,				"\\ismtp\\rcpthosts.txt");

	Set(CONFIG_MAXMAILSIZE,				"1024000");
	Set(CONFIG_SMTPDTIMEOUT,			"120");

	/* smtp auth */
	Set(CONFIG_USESMTPAUTHPLAIN,		"No");
	Set(CONFIG_USESMTPAUTHLOGIN,		"No");
	Set(CONFIG_USESMTPAUTHCRAMMD5,		"Yes");
	Set(CONFIG_USESMTPAUTHDIGESTMD5,	"No");

	/* smtp timeout(sec) */
	Set(CONFIG_SMTPGREETINGTIMEOUT,		"300");
	Set(CONFIG_SMTPMAILTIMEOUT,			"300");
	Set(CONFIG_SMTPRCPTTIMEOUT,			"300");
	Set(CONFIG_SMTPDATASTARTTIMEOUT,	"120");
	Set(CONFIG_SMTPDATABLOCKTIMEOUT,	"180");
	Set(CONFIG_SMTPDATABLOCKTIMEOUT,	"600");

	/* pop3 server */
	Set(CONFIG_POP3SERVERS,				"4");
	Set(CONFIG_POP3PORT,				"110");
	Set(CONFIG_PASSWDFILE,				"\\ismtp\\passwd.txt");
	Set(CONFIG_USEAPOPONLY,				"No");

	/* System watermark */
	Set(CONFIG_STRAGEWATERMARK,			"0");
	Set(CONFIG_MEMORYWATERMARK,			"512000");


// ----------------------------------------------------
	// load
	// ----------------------------------------------------
	this->LoadFile(CONFIG_FILE);

	if( 64*1024 > GetUINTValueI( CONFIG_MAXMAILSIZE ) )
		Set( CONFIG_MAXMAILSIZE, 64*1024 );
}

MyConf::~MyConf()
{

}
