/* =========================================================================
	This library is part of IshiSoft base class.
	------------------------------------------------------------------------
	author: Yuichiro Ishitani
			http://www001.upp.so-net.ne.jp/ishi/index.html
  ========================================================================== */
#if !defined(_MMyHashEx_H__INCLUDED_)
#define _MMyHashEx_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MyVarMem.h"

typedef const char* SEEKKEY;


/* ****************************************************************************

  $detail

  Key and Value can be registered in a pair. 
  Addition, deletion, reference, and listing can be performed.

  $Basic memory format.

  |key1|\0|value1|\0|key2|\0|value2|...|keyN|\0|valueN|\0|\0|

  ETermination is |\0|\0|
  EThe value |\0| is OK
    |key1|\0|\0|key2|...

**************************************************************************** */
class MyHashEx
{
protected:
	MyVarMem*	m_pHeap;					// Variable memory class
	
public:
	void* GetBuffer() const;
	int GetLength()	const		{if( NULL != m_pHeap ) return m_pHeap->GetLength(); return 0;}

	SEEKKEY	SeekToFirst();
	SEEKKEY SeekNext(SEEKKEY pszKey);
	SEEKKEY	SeekToKey( const char* pszKey );
	SEEKKEY	SeekToKeyI(const char* pszKey);

	void	Clear()				{m_pHeap->Clear();}
	MyHashEx();
	virtual ~MyHashEx();

	int			Set( const char* pszKey, const char* pszValue );
	int			Set( const char* pszKey, unsigned long dwValue );
	int			Del( const char* pszKey );
	const char*		GetValue( const char* pszKey );
	const char*		GetValueI( const char* pszKey );
	const char*		GetValueBySeekKey(SEEKKEY pszKey);
};

#endif // !defined(_MMyHash_H__INCLUDED_)
