/* =========================================================================
	This library is part of IshiSoft application.
	------------------------------------------------------------------------
	author: Yuichiro Ishitani
			http://www001.upp.so-net.ne.jp/ishi/index.html
  ========================================================================== */
#include "stdafx.h"
#include "MyLog.h"
#include "stdio.h"
#include "str.h"
#include "wincemem.h"

char* MyLog::m_pszMonth[12] =
{
	"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
};

MyLog::MyLog()
{
	this->m_nProtocol = SOCK_DGRAM;
	this->Connect( "127.0.0.1", "514" );
	this->SetTimeOut( 0, 100 );
	this->m_nFacility = LOGFACILITY_USER;
	m_pszTag = NULL;

	m_szHost[255] = '\0';

	if( 0 != gethostname( m_szHost, 255 ) )
	{
		STRCPY( m_szHost, "localhost" );
	}
	InitializeCriticalSection(&m_cs);
}

MyLog::~MyLog()
{
	this->Close();
	FREEIF( m_pszTag );
	DeleteCriticalSection( &m_cs );
}

void MyLog::Msg(const char *pszMsg,unsigned int nServerity /*=LOGSEVERITY_INFO*/)
{
	EnterCriticalSection( &m_cs );
	
	unsigned int nPri = 0;

	if( nServerity > LOGSEVERITY_LAST )
		nServerity = LOGSEVERITY_INFO;

	nPri = (m_nFacility * 8) + nServerity;

	SYSTEMTIME		st;
	GetLocalTime(&st);
	char* pszMon = m_pszMonth[st.wMonth-1];

	char* pszTag = m_pszTag;
	if( NULL == pszTag )
		pszTag = "";


	char szMsg[1024+1];
	_snprintf( szMsg, 1024, "<%d>%s %2d %02d:%02d:%02d %s %s: %s"
		, nPri, pszMon, st.wDay, st.wHour, st.wMinute, st.wSecond, m_szHost, pszTag, pszMsg );

	// message check
	char* p = szMsg;
	while( '\0' != *p )
	{
		if( *p > 126 || *p < 32 )
			*p = '.';
		p++;
	}

	this->SendData( szMsg );
	LeaveCriticalSection( &m_cs );

}

void MyLog::SetFacility(int nFacility)
{
	if( nFacility > LOGFACILITY_LAST )
		nFacility = LOGFACILITY_LOCAL7;
	m_nFacility = nFacility;
}

void MyLog::SetTag(const char *pszTag)
{
	if( NULL != pszTag )
	{
		m_pszTag = (char*)MALLOC(STRLEN(pszTag)+1);
		STRCPY(m_pszTag, pszTag);
	}
	else
	{
		m_pszTag = NULL;
	}
}
