/* =========================================================================
	This library is part of IshiSoft base class.
	------------------------------------------------------------------------
	author: Yuichiro Ishitani
			http://www001.upp.so-net.ne.jp/ishi/index.html
  ========================================================================== */
#if !defined(AFX_MYLOG_H__9AF1F6F9_120D_4F95_B36F_F1F685866669__INCLUDED_)
#define AFX_MYLOG_H__9AF1F6F9_120D_4F95_B36F_F1F685866669__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MySock.h"


#define LOGSEVERITY_EMERG	0
#define LOGSEVERITY_ALERT	1
#define LOGSEVERITY_CRIT	2
#define LOGSEVERITY_ERR		3
#define LOGSEVERITY_WARNING	4
#define LOGSEVERITY_NOTICE	5
#define LOGSEVERITY_INFO	6
#define LOGSEVERITY_DEBUG	7
#define LOGSEVERITY_LAST	7

#define LOGFACILITY_KERN		0
#define LOGFACILITY_USER		1
#define LOGFACILITY_MAIL		2
#define LOGFACILITY_DAEMON		3
#define LOGFACILITY_AUTH		4
#define LOGFACILITY_SYSLOG		5
#define LOGFACILITY_LPR			6
#define LOGFACILITY_NEWS		7
#define LOGFACILITY_UUCP		8
#define LOGFACILITY_CRON		9
#define LOGFACILITY_AUTHPRIV	10
#define LOGFACILITY_FTP			11
#define LOGFACILITY_NTP			12
#define LOGFACILITY_SECURITY	13
#define LOGFACILITY_CONSOLE		14
#define LOGFACILITY_CLKDAEMON	15
#define LOGFACILITY_LOCAL0		16
#define LOGFACILITY_LOCAL1		17
#define LOGFACILITY_LOCAL2		18
#define LOGFACILITY_LOCAL3		19
#define LOGFACILITY_LOCAL4		20
#define LOGFACILITY_LOCAL5		21
#define LOGFACILITY_LOCAL6		22
#define LOGFACILITY_LOCAL7		23
#define LOGFACILITY_LAST		23

class MyLog : public MySock  
{
public:
	void SetTag(const char* pszTag);
	void SetFacility(int nFacility);
	MyLog();
	virtual ~MyLog();
	void Msg(const char *pszMsg,unsigned int nServerity = LOGSEVERITY_INFO);

	void Err(const char *pszMsg) {Msg(pszMsg, LOGSEVERITY_ERR);}
	void Warn(const char *pszMsg) {Msg(pszMsg, LOGSEVERITY_WARNING);}
	void Info(const char *pszMsg) {Msg(pszMsg, LOGSEVERITY_INFO);}
	void Dbg(const char *pszMsg) {Msg(pszMsg, LOGSEVERITY_DEBUG);}

protected:
	static char*	m_pszMonth[12];
	int m_nFacility;
	char m_szHost[256];
	char* m_pszTag;
	CRITICAL_SECTION m_cs;
};

#endif // !defined(AFX_MYLOG_H__9AF1F6F9_120D_4F95_B36F_F1F685866669__INCLUDED_)
