/* =========================================================================
	This library is part of IshiSoft base class.
	------------------------------------------------------------------------
	author: Yuichiro Ishitani
			http://www001.upp.so-net.ne.jp/ishi/index.html
  ========================================================================== */
#if !defined(AFX_MYSOCK_H__0EC3C44A_5D45_41B6_A079_D7B2261F0431__INCLUDED_)
#define AFX_MYSOCK_H__0EC3C44A_5D45_41B6_A079_D7B2261F0431__INCLUDED_

#ifndef _WINSOCKAPI_
	#include <Winsock.h>
#endif

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define	WINSOCK_VERSION_REQUIRED	0x0101
#define	WINSOCK_MIN_SOCKETS_REQUIRED	1

#define PDELETE(p)	{if(p) delete p;p=NULL;}


class MySock  
{
public:
	int m_status;

public:
	//MySock();
	MySock(int nProtocol = SOCK_STREAM);
	MySock(SOCKET s);
	virtual ~MySock();

protected:
	static int InitDll();
	SOCKET			m_socket;
	int				m_nProtocol;
	timeval			m_timeout;
public:
//	sockaddr_in		m_from;

public:

	int				IsReadable();
	const SOCKET	GetSocket()	{return m_socket;}
	void			SetSocket(SOCKET s)	{m_socket = s;}
	void			SetTimeOut( long sec, long usec = 0 )		
						{m_timeout.tv_sec = sec; m_timeout.tv_usec = usec;}
	void			GetTimeOut(timeval* ptvTimeOut)
						{	ptvTimeOut->tv_sec = m_timeout.tv_sec;
							ptvTimeOut->tv_usec = m_timeout.tv_usec;
						}
	virtual void Close();
	int RecvData(char* buf, int len, int flag = 0);
	int RecvFrom(char *pBuf, int nBufLen, int nFlags = 0, sockaddr* pSockAddr = NULL, int* pnAddrLen = NULL);
	int SendData(const char* buf, int len = 0, int flag = 0);
	int SendTo(const char *buf, int len, int flag, sockaddr* pSockAddr, int nAddrLen);
	int Bind(int nPort);
	int Listen(int nPort);
	int Connect(const char* ipaddr, const char* port);
	SOCKET Accept();
	SOCKET Accept(sockaddr_in* pFrom);

};

#endif // !defined(AFX_MYSOCK_H__0EC3C44A_5D45_41B6_A079_D7B2261F0431__INCLUDED_)
