/* =========================================================================
	This library is part of IshiSoft application.
	------------------------------------------------------------------------
	author: Yuichiro Ishitani
			http://www001.upp.so-net.ne.jp/ishi/index.html
  ========================================================================== */
#include "stdafx.h"
#include "MyString.h"
#include "wincemem.h"
#include "str.h"

static char* pszZeroString = "";
static WCHAR* pwszZeroString = L"";

MyString::MyString()
{
	m_pwszWideString = NULL;
	m_pszString = NULL;
}

MyString::MyString( const char* pszSrc )
{
	m_pwszWideString = NULL;
	m_pszString = NULL;
	Set( pszSrc );
}

MyString::MyString( const WCHAR* pwszSrc )
{
	m_pwszWideString = NULL;
	m_pszString = NULL;
	Set( pwszSrc );
}

//-----------------------------------------------------------------------------
//	@detail
//		
//	@param
//		
//	@return
//		
//-----------------------------------------------------------------------------
MyString::~MyString()
{
	FREEIF( m_pszString );
	FREEIF( m_pwszWideString );
}

//-----------------------------------------------------------------------------
//	@detail
//		
//	@param
//		
//	@return
//		
//-----------------------------------------------------------------------------
int MyString::Set(const char *pszSrc)
{
	FREEIF( m_pszString );
	FREEIF( m_pwszWideString );

	m_pszString = STRDUP( pszSrc );

	if( NULL == m_pszString )
		return 0;
	return 1;
}

//-----------------------------------------------------------------------------
//	@detail
//		Set
//	@param
//		const WCHAR *pwszSrc
//	@return
//		
//-----------------------------------------------------------------------------
int MyString::Set(const WCHAR *pwszSrc)
{
	int len = 0;

	FREEIF( m_pszString );
	FREEIF( m_pwszWideString );

	if( NULL == pwszSrc )
		return 0;

	len = WideCharToMultiByte( CP_ACP, 0, pwszSrc, -1, NULL, 0, NULL, NULL );
	if( len == 0 )
	{
		return 0;
	}

	m_pszString = (char*)MALLOC( len + 1 );

	if( NULL == m_pszString )
		return 0;

	memset( m_pszString, 0, len + 1 );

	if( 0 == WideCharToMultiByte( CP_ACP, 0, pwszSrc, -1, m_pszString, len, NULL, NULL ) )
	{
		FREEIF( m_pszString );
	}
	return 1;
}

//-----------------------------------------------------------------------------
//	@detail
//		operator const char*()
//	@param
//		
//	@return
//		
//-----------------------------------------------------------------------------
MyString::operator const char*()
{
	if( NULL != m_pszString )
		return m_pszString;
	else
		return pszZeroString;
}

MyString::operator const WCHAR*()
{
	int len = 0;
	
	if( NULL != m_pwszWideString )
		return m_pwszWideString;

	if( NULL == m_pszString )
		return pwszZeroString;

	len = MultiByteToWideChar( CP_ACP, 0, m_pszString, -1, NULL, 0);
	
	if( 0 == len )
		return pwszZeroString;

	m_pwszWideString = (WCHAR*)MALLOC( (len+1) * sizeof(WCHAR) );
	
	if( NULL == m_pwszWideString )
		//return NULL;
		return pwszZeroString;

	if( 0 == MultiByteToWideChar( CP_ACP, 0, m_pszString, -1, m_pwszWideString, len ) )
	{
		FREEIF( m_pwszWideString );
		return pwszZeroString;
	}
	
	return m_pwszWideString;
}

void MyString::Clear()
{
	FREEIF( m_pszString );
	FREEIF( m_pwszWideString );
}
