/* =========================================================================
	This library is part of IshiSoft base class.
	------------------------------------------------------------------------
	author: Yuichiro Ishitani
			http://www001.upp.so-net.ne.jp/ishi/index.html
  ========================================================================== */
#if !defined(__STATICVALUE_H__INCLUDED__)
#define __STATICVALUE_H__INCLUDED__

#define gstr_CRLF	"\r\n"

#if !defined( MAX_PATH )
#define MAX_PATH          260
#endif

/* RFC2822 2.1.1. Line Length Limits
   There are two limits that this standard places on the number of
   characters in a line. Each line of characters MUST be no more than
   998 characters, and SHOULD be no more than 78 characters, excluding
   the CRLF.
*/
#define MAX_CMDLINE				998
/*
	4.5.3.1 Size limits and minimums
	local-part : The maximum total length of a user name or other local-part is 64 characters.
	domain : The maximum total length of a domain name or number is 255 characters.
	path : The maximum total length of a reverse-path or forward-path is 256 characters
	       (including the punctuation and element separators).
*/
#define MAX_MAILADDR_LEN256		256
#define MAX_LOCALUSERNAME_LEN64	64
#define MAX_PASSWORD_LEN64		64
#define MAX_DOMAIN_LEN255		255
#define MAX_CONFIG_DIR_PATH			(MAX_PATH - MAX_LOCALUSERNAME_LEN64 -1)


// pop3 only
#define UNIQUE_ID_MAX_LEN		64
#define LOCKFILEMARK			".lock"

// sender smtp process
#define SENDERSMTP			"pigeon.exe"
#define LOGGER				"ilogger.exe"


#endif // !defined(__STATICVALUE_H__INCLUDED__)
