// -------------------------------------------------------------------------
// STR.H
// ANSI STANDARD C STRING LIBRARY
// date:	12/jul/2003
// author:	Yuichiro Ishitani <yu-ishi@ya2.so-net.ne.jp>
// -------------------------------------------------------------------------

#if !defined(size_t)
#define size_t unsigned int
#endif

#if !defined(_MYSTR_H_INCLUDED_)
#define _MYSTR_H_INCLUDED_


#if defined(__cplusplus)
extern "C" {
#endif

unsigned int ATOUI( const char* src );
int ATOI( const char* src );

size_t	STRLEN( const char *string );
char	*STRCPY( char *dst, const char *src );
char	*STRNCPY( char *dst, const char *src, size_t count );
char	*STRUPR( char *src );
char	*STRLWR( char *src );
char	*STRCAT( char *dst, const char *src );
char	*STRNCAT( char *dst, const char *src, size_t count );
char	*STRSET( char *src, int c );
int		STRCMP( const char *str1, const char *str2 );
int		STRICMP( const char *str1, const char *str2 );
int		STRNCMP( const char *str1, const char *str2, size_t count );
int		STRNICMP( const char *str1, const char *str2, size_t count );
char	*STRDUP( const char *src );
void	STRFREE( const char * p );
char	*STRREV( char *string );
char	*STRCHR( const char *string, int c );
char	*STRRCHR( const char *string, int c );
char	*STRSTR( const char *dst, const char *src );
size_t	STRSPN( const char *dst, const char *src );
size_t	STRCSPN( const char *dst, const char *src );
char	*STRTOK( char *dst, const char *dlmt );

#if defined(__cplusplus)
}
#endif

#endif	//_MYSTR_H_INCLUDED_
