/* =========================================================================
	This library is part of IshiSoft base class.
	------------------------------------------------------------------------
	author: Yuichiro Ishitani
			http://www001.upp.so-net.ne.jp/ishi/index.html
  ========================================================================== */
#if !defined(_WINCEMEM_H_INCLUDED_)
#define _WINCEMEM_H_INCLUDED_


#ifndef NULL
#ifdef __cplusplus
#define NULL    0
#else
#define NULL    ((void *)0)
#endif
#endif

#if defined(WIN32)
	#include "windows.h"
	#define MALLOC( size )		HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, size )
	#define REALLOC( p, size )	HeapReAlloc( GetProcessHeap(), HEAP_ZERO_MEMORY, p, size )
	#define FREE( p )			HeapFree( GetProcessHeap(), HEAP_NO_SERIALIZE, p )
	#define FREEIF( p )			{if(p) HeapFree( GetProcessHeap(), HEAP_NO_SERIALIZE, p );p=NULL;}
#else
	#include <malloc.h>
	#define MALLOC( size )		malloc( size )
	#define REALLOC( p, size )	realloc( p, size )
	#define FREE( p )			free( p )
	#define FREEIF( p )			{if(p) free(p);p=NULL;}
#endif

#endif // _WINCEMEM_H_INCLUDED_