/* =========================================================================
	This library is part of IshiSoft application.
	------------------------------------------------------------------------
	author: Yuichiro Ishitani
			http://www001.upp.so-net.ne.jp/ishi/index.html
  ========================================================================== */
#include "stdafx.h"
#include "MyAuthIPList.h"
#include "MyConf.h"
#include "str.h"
#include "mystring.h"
#include "commonhelper.h"

MyAuthIPList::MyAuthIPList()
{

}

MyAuthIPList::~MyAuthIPList()
{

}

int MyAuthIPList::Set(const char* pszDir, const char *pszHostName)
{
	if( NULL == pszDir || NULL == pszHostName )
		return 0;
	
	char szFile[MAX_PATH+1] = {0};
	STRCPY( szFile, pszDir );
	STRCAT( szFile, pszHostName );
	STRCAT( szFile, POPBEFORESMTPMARK );

	MyString sFile;

	if( 0 == sFile.Set(szFile) )
		return 0;

	// touch!
	HANDLE hFile = CreateFile( sFile, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, 0, NULL );

	if( hFile == INVALID_HANDLE_VALUE )
	{
		return 0;
	}

	CloseHandle( hFile );
	return 1;
}

int MyAuthIPList::Check(const char* pszDir, const char *pszHostName, unsigned long dwSec)
{
	if( NULL == pszDir || NULL == pszHostName )
		return 0;

	char szFile[MAX_PATH+1] = {0};
	STRCPY( szFile, pszDir );
	STRCAT( szFile, pszHostName );
	STRCAT( szFile, POPBEFORESMTPMARK );

	MyString sFile;

	if( 0 == sFile.Set(szFile) )
		return 0;

	// touch!
	HANDLE hFile = CreateFile( sFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL );

	if( hFile == INVALID_HANDLE_VALUE )
	{
		return 0;
	}

	FILETIME ftFile;
	GetFileTime( hFile, NULL, NULL, &ftFile );
	CloseHandle( hFile );

	SYSTEMTIME sys;
	FILETIME ftSys;
	GetSystemTime( &sys );
	SystemTimeToFileTime( &sys, &ftSys );


	if( 0 != FileTimeCmp( &ftSys, &ftFile, dwSec ) )
	{
		// timeover
		DeleteFile( sFile );
		return 0;
	}

	return 1;
}
