/* =========================================================================
	This library is part of IshiSoft base class.
	------------------------------------------------------------------------
	author: Yuichiro Ishitani
			http://www001.upp.so-net.ne.jp/ishi/index.html
  ========================================================================== */
#if !defined(AFX_MYPOP3LIST_H__39A4746C_C251_4B06_903C_795F4E7164B0__INCLUDED_)
#define AFX_MYPOP3LIST_H__39A4746C_C251_4B06_903C_795F4E7164B0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/* ==========================================================================
:data format
	key = val is formatted as follows
	"<szNum>" = "<szOctet><sp><filename>"
	filename is as unique id.

	ex.
	1=320 20050505-0132280502-00000.txt
	2=6400 20050505-0132280602-11111.txt
	...
	100=160 20050505-0132280602-99999.txt

  
:if delete command recieved, first byte of key is marked 'X'.
	X=320 20050505-0132280502-00000.txt
	X=6400 20050505-0132280602-11111.txt
	...
	X00=160 20050505-0132280602-99999.txt
	
:atoi can get octet
	octet = ATOUI(val)

	ex.
	octet = ATOUI(6400 20050505-0132280602-11111.txt);
	octet is 6400 dec.
*/

#define DELE_MARK	'X'
#define SEP_MARK	' '

#include "..\LIB\MyHashEx.h"

class MyPop3List : public MyHashEx  
{
public:
	unsigned long GetOctet( SEEKKEY pKey);
	const char* GetUID( SEEKKEY pKey);
	int Rset();
	int Update();
	int Dele(const char* pszKey);
	int Stat(unsigned long* dwCount, unsigned long* dwTotalOctet);
	int CreateList(const char* pszDir);
	MyPop3List();
	virtual ~MyPop3List();

private:
	int	Del( const char* pszKey ) {return 0;}
	unsigned long m_dwOctet;
	unsigned long m_dwCount;
	void Clear();
	char m_szHomeDir[MAX_PATH+1];
	MyHashEx m_hsDeleList;
};

#endif // !defined(AFX_MYPOP3LIST_H__39A4746C_C251_4B06_903C_795F4E7164B0__INCLUDED_)
