/* =========================================================================
	This library is part of IshiSoft base class.
	------------------------------------------------------------------------
	author: Yuichiro Ishitani
			http://www001.upp.so-net.ne.jp/ishi/index.html
  ========================================================================== */
#if !defined(AFX_MYPOP3SOCK_H__22A56D5B_469E_47E7_AD38_4B6B1E4A03B5__INCLUDED_)
#define AFX_MYPOP3SOCK_H__22A56D5B_469E_47E7_AD38_4B6B1E4A03B5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\LIB\MyConsole.h"
#include "MyLog.h"
#include "threadtype.h"
#include "MyHashEx.h"
#include "MyPop3List.h"
#include "staticvariable.h"

#define STATE_AUTHORIZATION	0
#define STATE_TRANSACTION	1
#define STATE_UPDATE		2

class MyPop3Sock : public MyConsole  
{
public:
	MyPop3Sock(ACCEPTTHREAD* pAT);
	virtual ~MyPop3Sock();
	int Dialogue();

protected:
	int Res(int bOK, const char *pMes = NULL );
	int Dispatch(char *pszCmdLine);
	int cmdNOOP(char *pszCmdLine);
	int cmdUSER(char *pszCmdLine);
	int cmdPASS(char *pszCmdLine);
	int cmdSTAT(char *pszCmdLine);
	int cmdLIST(char *pszCmdLine);
	int cmdRETR(char *pszCmdLine);
	int cmdDELE(char *pszCmdLine);
	int cmdRSET(char *pszCmdLine);
	int cmdQUIT(char *pszCmdLine);

	int cmdTOP(char *pszCmdLine);
	int cmdUIDL(char *pszCmdLine);
	int cmdAPOP(char *pszCmdLine);

protected:
	int Login();
	char			m_szAuthKey[MAX_DOMAIN_LEN255+32];
	ACCEPTTHREAD*	m_pAT;
	MyLog			m_log;
	int				m_nState;
	char			m_szUserName[MAX_LOCALUSERNAME_LEN64+1];
	unsigned long	m_dwOctets;
	MyPop3List		m_list;
};

#endif // !defined(AFX_MYPOP3SOCK_H__22A56D5B_469E_47E7_AD38_4B6B1E4A03B5__INCLUDED_)
