/* =========================================================================
	This library is part of IshiSoft base class.
	------------------------------------------------------------------------
	author: Yuichiro Ishitani
			http://www001.upp.so-net.ne.jp/ishi/index.html
  ========================================================================== */
#if !defined(AFX_MYSMTPSOCK_H__525E293A_285C_4F66_B603_84F71BCF2CAF__INCLUDED_)
#define AFX_MYSMTPSOCK_H__525E293A_285C_4F66_B603_84F71BCF2CAF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MyConsole.h"
#include "MyVarMem.h"
#include "MyHashEx.h"
#include "MyHashFile.h"
#include "MyTmpFileMgr.h"
#include "MyLog.h"
#include "threadtype.h"
class MySmtpSock : public MyConsole  
{
public:
	int Dialogue();
	MySmtpSock(ACCEPTTHREAD* pAT);
	virtual ~MySmtpSock();

protected:
	int m_nReceivedHeaderCount;
	int AddTraceFields();
	int Res(int nCode, const char* pMes = NULL);

	int Dispatch(char* pszCmdLine);
	
	int cmdNOOP(char*pszCmdLine);
	int cmdHELP(char *pszCmdLine);
	int cmdEHLO(char *pszCmdLine);
	int cmdHELO(char *pszCmdLine);
	int cmdAUTH(char *pszCmdLine);
	int recvAuthCRAMMD5(char*pszCmdLine);
	int recvAuthLOGIN(char*pszCmdLine);
	int cmdMAIL(char *pszCmdLine);
	int cmdRCPT(char *pszCmdLine);
	int cmdDATA(char *pszCmdLine);
	int recvDATA(char*pszCmdLine);
	int recvInvalidData(char *pszCmdLine);
	int cmdRSET(char *pszCmdLine);
	int cmdQUIT(char*pszCmdLine);
	int cmdVRFY(char *pszCmdLine);
	int cmdEXPN(char *pszCmdLine);

	MyTmpFileMgr	m_TmpFile;
	MyVarMem		m_vmFrom;
	MyVarMem		m_vmHelo;

	MyHashFile		m_hsRcptLocal;
	MyHashFile		m_hsRcptRemote;

	MyLog			m_log;
	int				m_bAuthorized;
	int				m_nCannnelMode;
	char*			m_pszAuthKey;
	char			m_szUserName[MAX_LOCALUSERNAME_LEN64+1];

	ACCEPTTHREAD*	m_pAT;
	unsigned int	m_unMaxMailSize;
};

#endif // !defined(AFX_MYSMTPSOCK_H__525E293A_285C_4F66_B603_84F71BCF2CAF__INCLUDED_)
