/* =========================================================================
	This library is part of IshiSoft application.
	------------------------------------------------------------------------
	author: Yuichiro Ishitani
			http://www001.upp.so-net.ne.jp/ishi/index.html
  ========================================================================== */
#include "stdafx.h"
#include "daemon.h"
#include "MyAuthIPList.h"
#include "MyConf.h"
#include "MyLog.h"
#include "str.h"
#include "MyString.h"
#include "staticvariable.h"
#include "commonhelper.h"

extern MyConf	g_conf;
extern MyLog	g_log;

VOID CALLBACK DaemonSenderSMTP( HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime )
{
	int nRet;
	nRet = StartProcess(SENDERSMTP, NULL);
		
	if( nRet )
	{
		g_log.Dbg( "Pigeon regular round." );
	}
	else
	{
		g_log.Err( "Pigeon regular round, create process failed." );
	}
	return;
}

VOID CALLBACK DaemonCleanUp( HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime )
{
	MyString sDir;
	HANDLE hff = INVALID_HANDLE_VALUE;
	WIN32_FIND_DATA wfd = {0};
	char szDir[MAX_PATH+1] = {0};

	g_log.Dbg( "cleanup thread regular round." );

	// ----------------------------------------------------
	// Delete Pop before SMTP file
	// ----------------------------------------------------
	STRCPY( szDir, g_conf.GetValueI(CONFIG_POPAUTHDIR) );
	STRCAT( szDir, "*" );
	STRCAT( szDir, POPBEFORESMTPMARK );

	if( 0 == sDir.Set( szDir ) )
	{
		return;	//no memory
	}

	hff = FindFirstFile( sDir, &wfd );

	if( INVALID_HANDLE_VALUE != hff )
	{
		MyAuthIPList ip;

		do
		{
			if( FILE_ATTRIBUTE_DIRECTORY & wfd.dwFileAttributes )
			{
				continue;
			}

			MyString sFileName;
			if( 0 != sFileName.Set(wfd.cFileName) )
			{
				ip.Check( g_conf.GetValueI(CONFIG_POPAUTHDIR), sFileName, g_conf.GetUINTValueI(CONFIG_POPAUTHTIMEOUT) );
			}

		}while( FindNextFile( hff, &wfd ) );
		
		FindClose( hff );
	}

	// ----------------------------------------------------
	// Delete lock file
	// ----------------------------------------------------
	STRCPY( szDir, g_conf.GetValueI(CONFIG_HOMEDIR) );
	STRCAT( szDir, "*" );
	STRCAT( szDir, LOCKFILEMARK );
	if( 0 == sDir.Set( szDir ) )
	{
		return;	//no memory
	}

	hff = FindFirstFile( sDir, &wfd );

	if( INVALID_HANDLE_VALUE != hff )
	{
		do
		{
			if( FILE_ATTRIBUTE_DIRECTORY & wfd.dwFileAttributes )
				continue;
		
			MyString sFile;
			if( 0 != sFile.Set(wfd.cFileName) )
			{
				STRCPY( szDir, g_conf.GetValueI(CONFIG_HOMEDIR) );
				STRCAT( szDir, sFile );
				
				MyString sDeleteFile;
				if( 0 != sDeleteFile.Set( szDir ) )
				{
					DeleteFile( sDeleteFile );
				}
			}
		}while( FindNextFile( hff, &wfd ) );
		
		FindClose( hff );
	}

	// ----------------------------------------------------
	// Delete tmp file
	// ----------------------------------------------------
	STRCPY( szDir, g_conf.GetValueI(CONFIG_TMPDIR) );
	STRCAT( szDir, "*.*" );
	if( 0 == sDir.Set( szDir ) )
	{
		return;	//no memory
	}

	hff = FindFirstFile( sDir, &wfd );

	if( INVALID_HANDLE_VALUE != hff )
	{
		do
		{
			if( FILE_ATTRIBUTE_DIRECTORY & wfd.dwFileAttributes )
				continue;

			MyString sFile;
			if( 0 != sFile.Set(wfd.cFileName) )
			{
				STRCPY( szDir, g_conf.GetValueI(CONFIG_TMPDIR) );
				STRCAT( szDir, sFile );
				
				MyString sDeleteFile;
				if( 0 != sDeleteFile.Set( szDir ) )
				{
					DeleteFile( sDeleteFile );
				}
			}
		}while( FindNextFile( hff, &wfd ) );
		
		FindClose( hff );
	}
}
